Description

Valgrind showed the following issues related to PdspNoiseRemoval_tool.cc

==3829== Invalid read of size 2

==3829== at 0x59ECD450: PdspNoiseRemoval::getMedianCorrection (std::vector<unsigned int, std::al
locator<unsigned int> > consté&, std::map<unsigned int, AdcChannelData, std::less<unsigned int>, st
d::allocator<std::pair<unsigned int const, AdcChannelData> > > consté&) const (PdspNoiseRemoval_too
l.cc:315)

==3829== by 0x59ECCAES5: PdspNoiseRemoval::removeCoherent (std::unordered_map<unsigned int, std::
vector<unsigned int, std::allocator<unsigned int> >, std::hash<unsigned int>, std::equal_to<unsign
ed int>, std::allocator<std::pair<unsigned int const, std::vector<unsigned int, std::allocator<uns
igned int> > > > > consté&, std::map<unsigned int, AdcChannelData, std::less<unsigned int>, std::al
locator<std::pair<unsigned int const, AdcChannelData> > >&) const (PdspNoiseRemoval_tool.cc:253)
==3829== by O0x59ECBY90F: PdspNoiseRemoval::updateMap (std::map<unsigned int, AdcChannelData, std:
:less<unsigned int>, std::allocator<std::pair<unsigned int const, AdcChannelData> > >&) const (Pds
pNoiseRemoval_tool.cc:119)

==3829== by 0x25BE8917: ToolBasedRawDigitPrepService: :prepare (std::map<unsigned int, AdcChannel
Data, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, AdcChannelData> > >&,
std::vector<recob::Wire, std::allocator<recob::Wire> >*, WiredAdcChannelDataMap*) const (ToolBased
RawDigitPrepService_service.cc:69)

==3829== by 0x2C5F4707: DataPrepModule: :produce (art::Eventé&) (DataPrepModule_module.cc:540)
==3829== by O0x5F83F48: art::EDProducer::produceWithFrame (art::Event&, art::ProcessingFrame cons
t&) (EDProducer.cc:88)

==3829== by 0x6059541: art::detail::Producer::doEvent (art::EventPrincipal&, art::ModuleContext

consté&, std::atomic<unsigned long>&, std::atomic<unsigned long>&, std::atomic<unsigned long>&) (Pr
oducer.cc:121)

==3829== by 0x26E5D80D: art::WorkerT<art::EDProducer>::implDoProcess (art::EventPrincipalé&, art:
:ModuleContext consté&) (WorkerT.h:182)

==3829== by 0x66F9778: art::Worker::runWorker (art::EventPrincipal&, art::ModuleContext consté&)
(Worker.cc:591)

==3829== by 0x66F94BD: art:: (anonymous namespace) : :RunWorkerFunctor: :operator () () const (Worker
.cc:569)

==3829== by 0x66FCClE: void hep::concurrency::SerialTaskQueueChain: :runFunc<art:: (anonymous nam
espace) : :RunWorkerFunctor> (art:: (anonymous namespace) : :RunWorkerFunctor consté&) (SerialTaskQueueCh
ain.h:83)

==3829== by 0x66FD011: void hep::concurrency::SerialTaskQueueChain: :passDown<art:: (anonymous na
mespace) : :RunWorkerFunctor> (unsigned int, art:: (anonymous namespace) ::RunWorkerFunctor consté&) ::{1
ambda () #1}::operator () () (SerialTaskQueueChain.h:69)

==3829== Address 0x90d21bc8 is 0 bytes after a block of size 11,992 alloc'd

==3829== at 0x4C2A243: operator new(unsigned long) (vg_replace_malloc.c:334)

==3829== by 0x13195C28: __ _gnu_cxx::new_allocator<short>::allocate (unsigned long, void const*) (
new_allocator.h:111)

==3829== by 0x13194EBD: std::allocator_traits<std::allocator<short> >::allocate(std::allocator<
short>§&, unsigned long) (alloc_traits.h:436)

==3829== by 0x1318E345: std::_Vector_base<short, std::allocator<short> >::_M_allocate (unsigned
long) (stl_vector.h:172)

==3829== by 0x235486E5: std::vector<short, std::allocator<short> >::_M fill_insert (__gnu_cxx::_

_normal_iterator<short*, std::vector<short, std::allocator<short> > >, unsigned long, short consté&
) (vector.tcc:505)

==3829== by 0x235472D1: std::vector<short, std::allocator<short> >::resize(unsigned long, short
consté&) (stl_vector.h:712)
==3829== by 0x5AA972BF: FloatArrayGainCalibration::update (AdcChannelData&) const (FloatArrayGai
nCalibration_tool.cc:76)

==3829== by 0x25686384: AdcChannelTool::updateMap (std::map<unsigned int, AdcChannelData, std::1
ess<unsigned int>, std::allocator<std::pair<unsigned int const, AdcChannelData> > >&) const (AdcCh
annelTool.h:128)

==3829== by 0x25BE8917: ToolBasedRawDigitPrepService: :prepare (std::map<unsigned int, AdcChannel
Data, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, AdcChannelData> > >&,
std::vector<recob::Wire, std::allocator<recob::Wire> >*, WiredAdcChannelDataMap*) const (ToolBased
RawDigitPrepService_service.cc:69)

==3829== by 0x2C5F4707: DataPrepModule: :produce (art::Eventé&) (DataPrepModule_module.cc:540)
==3829== by 0x5F83F48: art::EDProducer::produceWithFrame (art::Eventé&, art::ProcessingFrame cons
t&) (EDProducer.cc:88)

==3829== by 0x6059541: art::detail::Producer::doEvent (art::EventPrincipalé&, art::ModuleContext

consté&, std::atomic<unsigned long>&, std::atomic<unsigned long>&, std::atomic<unsigned long>&) (Pr
oducer.cc:121)

==3829==
==3829== Invalid read of size 4
==3829== at 0x59ECCC29: PdspNoiseRemoval::removeCoherent (std::unordered_map<unsigned int, std::

vector<unsigned int, std::allocator<unsigned int> >, std::hash<unsigned int>, std::equal_to<unsign
ed int>, std::allocator<std::pair<unsigned int const, std::vector<unsigned int, std::allocator<uns
igned int> > > > > consté&, std::map<unsigned int, AdcChannelData, std::less<unsigned int>, std::al
locator<std::pair<unsigned int const, AdcChannelData> > >&) const (PdspNoiseRemoval_tool.cc:261)
==3829== by O0x59ECBY90F: PdspNoiseRemoval::updateMap (std::map<unsigned int, AdcChannelData, std:
:less<unsigned int>, std::allocator<std::pair<unsigned int const, AdcChannelData> > >&) const (Pds
pNoiseRemoval_tool.cc:119)

==3829== by 0x25BE8917: ToolBasedRawDigitPrepService: :prepare (std::map<unsigned int, AdcChannel
Data, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, AdcChannelData> > >&,
std::vector<recob::Wire, std::allocator<recob::Wire> >*, WiredAdcChannelDataMap*) const (ToolBased
RawDigitPrepService_service.cc:69)

==3829== by 0x2C5F4707: DataPrepModule: :produce (art::Eventé&) (DataPrepModule_module.cc:540)
==3829== by O0x5F83F48: art::EDProducer::produceWithFrame (art::Event&, art::ProcessingFrame cons
t&) (EDProducer.cc:88)

==3829== by 0x6059541: art::detail::Producer::doEvent (art::EventPrincipals&, art::ModuleContext

consté&, std::atomic<unsigned long>&, std::atomic<unsigned long>&, std::atomic<unsigned long>&) (Pr
oducer.cc:121)

==3829== by 0x26E5D80D: art::WorkerT<art::EDProducer>::implDoProcess (art::EventPrincipal&, art:
:ModuleContext consté&) (WorkerT.h:182)

==3829== by 0x66F9778: art::Worker::runWorker (art::EventPrincipal&, art::ModuleContext consté&)
(Worker.cc:591)

==3829== by 0x66F94BD: art:: (anonymous namespace) ::RunWorkerFunctor: :operator () () const (Worker
.cc:569)

==3829== by 0x66FCClE: void hep::concurrency::SerialTaskQueueChain: :runFunc<art:: (anonymous nam

espace) : :RunWorkerFunctor> (art:: (anonymous namespace) : :RunWorkerFunctor consté&) (SerialTaskQueueCh

ain.h:83)

==3829== by 0x66FD011: void hep::concurrency::SerialTaskQueueChain: :passDown<art:: (anonymous na

mespace) : :RunWorkerFunctor> (unsigned int, art:: (anonymous namespace) ::RunWorkerFunctor consté&) ::{1

ambda () #1}::operator () () (SerialTaskQueueChain.h:69)

==3829== by O0x66FDC74: hep::concurrency: :QueuedTask<void hep::concurrency::SerialTaskQueueChain
: :passDown<art:: (anonymous namespace) : :RunWorkerFunctor> (unsigned int, art:: (anonymous namespace) :
:RunWorkerFunctor consté&) ::{lambda () #1}>::execute() (SerialTaskQueue.h:87)

==3829== Address 0x957a58a0 is 0 bytes after a block of size 24,000 alloc'd

==3829== at 0x4C2A243: operator new(unsigned long) (vg_replace_malloc.c:334)

==3829== by 0x123ED049: __ gnu_cxx::new_allocator<float>::allocate(unsigned long, void const*) (

new_allocator.h:111)

==3829== by 0x123EC12D: std::allocator_traits<std::allocator<float> >::allocate(std::allocator<
float>&, unsigned long) (alloc_traits.h:436)

==3829== by 0x123EA977: std::_Vector_base<float, std::allocator<float> >::_M allocate (unsigned
long) (stl_vector.h:172)

==3829== by 0x199C79DC: std::_Vector_base<float, std::allocator<float> >::_M_create_storage (uns

igned long) (stl_vector.h:187)

==3829== by 0x199C7838: std::_Vector_base<float, std::allocator<float> >::_Vector_base (unsigned
long, std::allocator<float> consté&) (stl_vector.h:138)

==3829== by 0x1E6B2445: std::vector<float, std::allocator<float> >::vector (unsigned long, std::

allocator<float> consté&) (stl_vector.h:284)

==3829== by 0x59ECDS5BE: PdspNoiseRemoval::getMedianCorrection (std::vector<unsigned int, std::al

locator<unsigned int> > consté&, std::map<unsigned int, AdcChannelData, std::less<unsigned int>, st
d::allocator<std::pair<unsigned int const, AdcChannelData> > > consté&) const (PdspNoiseRemoval_too
1l.cc:329)
==3829== by 0x59ECCAES5: PdspNoiseRemoval::removeCoherent (std::unordered_map<unsigned int, std::
vector<unsigned int, std::allocator<unsigned int> >, std::hash<unsigned int>, std::equal_to<unsign
ed int>, std::allocator<std::pair<unsigned int const, std::vector<unsigned int, std::allocator<uns
igned int> > > > > consté&, std::map<unsigned int, AdcChannelData, std::less<unsigned int>, std::al
locator<std::pair<unsigned int const, AdcChannelData> > >&) const (PdspNoiseRemoval_tool.cc:253)
==3829== by O0x59ECBY90F: PdspNoiseRemoval::updateMap (std::map<unsigned int, AdcChannelData, std:
:less<unsigned int>, std::allocator<std::pair<unsigned int const, AdcChannelData> > >&) const (Pds
pNoiseRemoval_tool.cc:119)

==3829== by 0x25BE8917: ToolBasedRawDigitPrepService: :prepare (std::map<unsigned int, AdcChannel
Data, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, AdcChannelData> > >&,
std::vector<recob::Wire, std::allocator<recob::Wire> >*, WiredAdcChannelDataMap*) const (ToolBased
RawDigitPrepService_service.cc:69)

==3829== by 0x2C5F4707: DataPrepModule: :produce (art::Event&) (DataPrepModule_module.cc:540)
==3829==

History

#1 - 05/06/2019 11:53 AM - Tingjun Yang
| did a little more investigation and | believe the issue is caused by FEMB302 only having 5996 ticks.

In line 315 of PdspNoiseRemoval_tool.cc:
AdcFlag flag = acd.flags.size() ? acd.flags[s] : AdcGood;
acd.flags.size() is 5996 for FEMB302 but s can always go up to 5999.
There may be another problem around line 260:
for(size_t s = 0; s < acd.samples.size(); ++s) {

acd.samples([s] —-= correction([s];

}

#2 - 05/09/2019 12:40 PM - Jingbo Wang

A quick fix is to replace line 281, 290, 315, 323 by
AdcFlag flag = (acd.flags.size()!=0 && s<acd.flags.size()) ? acd.flags[s] : AdcGood;

The above line assures that acd.flags[s] does exist.

#3 - 05/11/2019 03:27 PM - Tingjun Yang

- Status changed from Assigned to Resolved

Fixed by Jingbo
9ee9443dea6359366986cc0dbd23cca88b6250c0

#4 - 05/11/2019 03:27 PM - Tingjun Yang

- Status changed from Resolved to Closed
